Core-10

For instructions on how to authenticate to use this endpoint, see API overview.

Endpoints

PATCH
DELETE
GET
POST
GET
GET
GET
GET
GET
GET
POST
GET
GET
GET
POST
GET
PATCH
DELETE

Update event definitions

Required API key scopes

event_definition:write

Path parameters

  • id
    string

Request parameters

  • name
    string
  • owner
    integernull
  • description
    stringnull
  • tags
    array
  • verified
    boolean
  • hidden
    booleannull
  • enforcement_mode
  • primary_property
    stringnull
  • post_to_slack
    boolean
    Default: false
  • default_columns
    array

Response


Example request

PATCH /api/projects/:project_id/event_definitions/:id
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl -X PATCH \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/event_definitions/:id/\
-d name="string"

Example response

Status 200
RESPONSE
{
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"name": "string",
"owner": 0,
"description": "string",
"tags": [
null
],
"created_at": "2019-08-24T14:15:22Z",
"updated_at": "2019-08-24T14:15:22Z",
"updated_by": {
"id": 0,
"uuid": "095be615-a8ad-4c33-8e9c-c7612fbf6c9f",
"distinct_id": "string",
"first_name": "string",
"last_name": "string",
"email": "user@example.com",
"is_email_verified": true,
"hedgehog_config": {},
"role_at_organization": "engineering"
},
"last_seen_at": "2019-08-24T14:15:22Z",
"last_updated_at": "2019-08-24T14:15:22Z",
"verified": true,
"verified_at": "2019-08-24T14:15:22Z",
"verified_by": {
"id": 0,
"uuid": "095be615-a8ad-4c33-8e9c-c7612fbf6c9f",
"distinct_id": "string",
"first_name": "string",
"last_name": "string",
"email": "user@example.com",
"is_email_verified": true,
"hedgehog_config": {},
"role_at_organization": "engineering"
},
"hidden": true,
"enforcement_mode": "allow",
"primary_property": "string",
"is_action": true,
"action_id": 0,
"is_calculating": true,
"last_calculated_at": "2019-08-24T14:15:22Z",
"created_by": {
"id": 0,
"uuid": "095be615-a8ad-4c33-8e9c-c7612fbf6c9f",
"distinct_id": "string",
"first_name": "string",
"last_name": "string",
"email": "user@example.com",
"is_email_verified": true,
"hedgehog_config": {},
"role_at_organization": "engineering"
},
"post_to_slack": false,
"default_columns": [
"string"
],
"media_preview_urls": [
"string"
]
}

Delete event definitions

Required API key scopes

event_definition:write

Path parameters

  • id
    string

Example request

DELETE /api/projects/:project_id/event_definitions/:id
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl -X DELETE \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/event_definitions/:id/

Example response

Status 204 No response body

Retrieve event definitions metrics

Path parameters

  • id
    string

Example request

GET /api/projects/:project_id/event_definitions/:id/metrics
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/event_definitions/:id/metrics/

Example response

Status 200 No response body

Create event definitions bulk update tags

Bulk update tags on multiple objects.

PAT access: this action has no required_scopes= on the decorator — inheriting viewsets must add "bulk_update_tags" to their scope_object_write_actions list to accept personal API keys. Without that opt-in, APIScopePermission rejects PAT requests with "This action does not support personal API key access". Done per-viewset so granting <scope>:write for one resource doesn't leak access to sibling resources that share this mixin.

Accepts:

  • {"ids": [...], "action": "add"|"remove"|"set", "tags": ["tag1", "tag2"]}

Actions:

  • "add": Add tags to existing tags on each object
  • "remove": Remove specific tags from each object
  • "set": Replace all tags on each object with the provided list

Request parameters

  • ids
    array
  • action
  • tags
    array

Response


Example request

POST /api/projects/:project_id/event_definitions/bulk_update_tags
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl
-H 'Content-Type: application/json'\
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/event_definitions/bulk_update_tags/\
-d ids="array",\
-d action=undefined,\
-d tags="array"

Example response

Status 200
RESPONSE
{
"updated": [
{
"id": 0,
"tags": [
"string"
]
}
],
"skipped": [
{
"id": 0,
"reason": "string"
}
]
}

Retrieve event definitions by name

Get event definition by exact name

Required API key scopes

event_definition:read

Query parameters

  • name
    string

Response


Example request

GET /api/projects/:project_id/event_definitions/by_name
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/event_definitions/by_name/

Example response

Status 200
RESPONSE
{
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"name": "string",
"created_at": "2019-08-24T14:15:22Z",
"last_seen_at": "2019-08-24T14:15:22Z",
"last_updated_at": "2019-08-24T14:15:22Z",
"tags": [
null
],
"enforcement_mode": "allow",
"primary_property": "string",
"is_action": true,
"action_id": 0,
"is_calculating": true,
"last_calculated_at": "2019-08-24T14:15:22Z",
"created_by": {
"id": 0,
"uuid": "095be615-a8ad-4c33-8e9c-c7612fbf6c9f",
"distinct_id": "string",
"first_name": "string",
"last_name": "string",
"email": "user@example.com",
"is_email_verified": true,
"hedgehog_config": {},
"role_at_organization": "engineering"
},
"post_to_slack": false
}

Retrieve event definitions golang

Required API key scopes

event_definition:read

Example request

GET /api/projects/:project_id/event_definitions/golang
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/event_definitions/golang/

Example response

Status 200 No response body

Retrieve event definitions primary properties

Resolve team-configured primary properties for event definitions.

The response only contains entries where a non-null primary_property is set on the EventDefinition. Callers should fall back to the core taxonomy defaults client-side for names not present in the response.

Required API key scopes

event_definition:read

Query parameters

  • names
    array

Response


Example request

GET /api/projects/:project_id/event_definitions/primary_properties
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/event_definitions/primary_properties/

Example response

Status 200
RESPONSE
{
"primary_properties": {
"property1": "string",
"property2": "string"
}
}

Retrieve event definitions python

Required API key scopes

event_definition:read

Example request

GET /api/projects/:project_id/event_definitions/python
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/event_definitions/python/

Example response

Status 200 No response body

Retrieve event definitions typescript

Required API key scopes

event_definition:read

Example request

GET /api/projects/:project_id/event_definitions/typescript
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/event_definitions/typescript/

Example response

Status 200 No response body

List all exports

Required API key scopes

export:read

Query parameters

  • limit
    integer
  • offset
    integer

Response


Example request

GET /api/projects/:project_id/exports
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/exports/

Example response

Status 200
RESPONSE
{
"count": 123,
"next": "http://api.example.org/accounts/?offset=400&limit=100",
"previous": "http://api.example.org/accounts/?offset=200&limit=100",
"results": [
{
"id": 0,
"dashboard": 0,
"insight": 0,
"export_format": "image/png",
"created_at": "2019-08-24T14:15:22Z",
"has_content": true,
"export_context": null,
"filename": "string",
"expires_after": "2019-08-24T14:15:22Z",
"exception": "string"
}
]
}

Create exports

Required API key scopes

export:write

Request parameters

  • dashboard
    integernull
  • insight
    integernull
  • export_format
  • export_context

Response


Example request

POST /api/projects/:project_id/exports
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl
-H 'Content-Type: application/json'\
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/exports/\
-d export_format=undefined

Example response

Status 201
RESPONSE
{
"id": 0,
"dashboard": 0,
"insight": 0,
"export_format": "image/png",
"created_at": "2019-08-24T14:15:22Z",
"has_content": true,
"export_context": null,
"filename": "string",
"expires_after": "2019-08-24T14:15:22Z",
"exception": "string"
}

Retrieve exports

Required API key scopes

export:read

Path parameters

  • id
    integer

Response


Example request

GET /api/projects/:project_id/exports/:id
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/exports/:id/

Example response

Status 200
RESPONSE
{
"id": 0,
"dashboard": 0,
"insight": 0,
"export_format": "image/png",
"created_at": "2019-08-24T14:15:22Z",
"has_content": true,
"export_context": null,
"filename": "string",
"expires_after": "2019-08-24T14:15:22Z",
"exception": "string"
}

Retrieve exports content

Required API key scopes

export:read

Path parameters

  • id
    integer

Example request

GET /api/projects/:project_id/exports/:id/content
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/exports/:id/content/

Example response

Status 200 No response body

List all file system

Required API key scopes

file_system:read

Query parameters

  • limit
    integer
  • offset
    integer
  • search
    string

Response


Example request

GET /api/projects/:project_id/file_system
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/file_system/

Example response

Status 200
RESPONSE
{
"count": 123,
"next": "http://api.example.org/accounts/?offset=400&limit=100",
"previous": "http://api.example.org/accounts/?offset=200&limit=100",
"results": [
{
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"path": "string",
"depth": 0,
"type": "string",
"ref": "string",
"href": "string",
"meta": null,
"shortcut": true,
"created_at": "2019-08-24T14:15:22Z",
"last_viewed_at": "2019-08-24T14:15:22Z"
}
]
}

Create file system

Required API key scopes

file_system:write

Request parameters

  • path
    string
  • type
    string
  • ref
    stringnull
  • href
    stringnull
  • meta
  • shortcut
    booleannull

Response


Example request

POST /api/projects/:project_id/file_system
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl
-H 'Content-Type: application/json'\
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/file_system/\
-d path="string"

Example response

Status 201
RESPONSE
{
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"path": "string",
"depth": 0,
"type": "string",
"ref": "string",
"href": "string",
"meta": null,
"shortcut": true,
"created_at": "2019-08-24T14:15:22Z",
"last_viewed_at": "2019-08-24T14:15:22Z"
}

Retrieve file system

Required API key scopes

file_system:read

Path parameters

  • id
    string

Response


Example request

GET /api/projects/:project_id/file_system/:id
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/file_system/:id/

Example response

Status 200
RESPONSE
{
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"path": "string",
"depth": 0,
"type": "string",
"ref": "string",
"href": "string",
"meta": null,
"shortcut": true,
"created_at": "2019-08-24T14:15:22Z",
"last_viewed_at": "2019-08-24T14:15:22Z"
}

Update file system

Required API key scopes

file_system:write

Path parameters

  • id
    string

Request parameters

  • path
    string
  • type
    string
  • ref
    stringnull
  • href
    stringnull
  • meta
  • shortcut
    booleannull

Response


Example request

PATCH /api/projects/:project_id/file_system/:id
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl -X PATCH \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/file_system/:id/\
-d path="string"

Example response

Status 200
RESPONSE
{
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"path": "string",
"depth": 0,
"type": "string",
"ref": "string",
"href": "string",
"meta": null,
"shortcut": true,
"created_at": "2019-08-24T14:15:22Z",
"last_viewed_at": "2019-08-24T14:15:22Z"
}

Delete file system

Required API key scopes

file_system:write

Path parameters

  • id
    string

Example request

DELETE /api/projects/:project_id/file_system/:id
export POSTHOG_PERSONAL_API_KEY=[your personal api key]
curl -X DELETE \
-H "Authorization: Bearer $POSTHOG_PERSONAL_API_KEY" \
<ph_app_host>/api/projects/:project_id/file_system/:id/

Example response

Status 204 No response body

Community questions

Questions about this page? or post a community question.